import React, { useEffect } from 'react';
import { APIProvider, Map, useMap } from '@vis.gl/react-google-maps';

// @ts-ignore
const GoogleMap = (props) => {
    const apiKey = process.env.NEXT_PUBLIC_GOOGLE_MAPS_API_KEY || 'AIzaSyAsh-ofw4XiKuvo4W1GOIutG7NpHLbp2Hw';

    return (
        <>
            <APIProvider apiKey={apiKey} libraries={['marker']}>
                <Map
                    mapId={'7a9e2ebecd32a903'}
                    style={{ width: '100%', height: '650px' }}
                    defaultCenter={{ lat: 37.7749, lng: -122.4194 }}
                    defaultZoom={18}
                    gestureHandling={'greedy'}
                    fullscreenControl={false}
                    {...props}
                >
                    {props?.children}
                </Map>
            </APIProvider>
        </>
    );
};


// @ts-ignore
export function PolylineMap({ path, strokeColor = 'rgba(15,83,255,0.7)' }) {
    const map = useMap();

    useEffect(() => {
        if (!map) return;

        // Create a Polyline object
        const polyline = new google.maps.Polyline({
            path: path,
            geodesic: true,
            strokeColor: strokeColor, // Color of the polyline
            strokeOpacity: 1.0,
            strokeWeight: 5,
            map: map,
        });

        // Clean up the polyline on component unmount
        return () => polyline.setMap(null);
    }, [map, path]);

    return <></>;
}


export default GoogleMap;


export const getMarkerIcon = (color: any) => ({
    path: 'M12 2C8.13 2 5 5.13 5 9c0 3.87 7 11 7 11s7-7.13 7-11c0-3.87-3.13-7-7-7z',
    fillColor: color,
    fillOpacity: 1,
    strokeColor: 'black',
    strokeWeight: 1,
    scale: 2.1,
    // Set the anchor point for the marker
    anchor: new google.maps.Point(12, 24),
    // Set the origin point of the marker (top-left corner)
    origin: new google.maps.Point(0, 0),
    // Set the position of the label relative to the marker
    labelOrigin: new google.maps.Point(12, 10),
    // Rotation of the marker in degrees (0-360)
    rotation: 0,
    // Determines whether the icon is aligned with the map (heading) or the marker itself (default)
    iconHeading: 0,
});